/**
  ******************************************************************************
  * @file    vks232.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vks232 functions. 
	*          ļ VKS232
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vks232.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VKS232_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VKS232ο·
unsigned char vks232_segtab[VKS232_SEGNUM]={
	 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,			//SEG0-SEG19
	20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,			//SEG20-SEG39
	40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,			//SEG40-SEG59
	60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,			//SEG60-SEG79
	80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,			//SEG80-SEG99
	100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115		//SEG100-SEG115	
};
//LCDʵֻSEG10SEG21ʹ
//.hļVKS232_SEGNUM=12
//const unsigned char vks232_segtab[VKS232_SEGNUM]={	
//	10,11,12,13,14,15,16,17,18,19,	//SEG10-SEG19
//	20,21,													//SEG20-SEG21
//};
//vks232_dispramӦоƬʾRAM
unsigned char vks232_dispram[VKS232_SEGNUM];
//Ӧvks232_segtab[VKS232_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
/M0=0 1/2BIAS 100%DUTY
//pin123-DSӵ͵ƽ
vks232_dispram[VKS232_SEGNUM]=
{//com1     com0 //ӦоƬSEG  ӦʾRAM
	1E,      1F,     //seg2   			vks232_dispram[1]-bit3-bit2  &~0xc0
	1G,      1A,     //seg3					vks232_dispram[1]-bit1-bit0  &~0x30
	1C,      1B,     //seg4					vks232_dispram[2]-bit3-bit2	 &~0x0c
	1D,      P1,     //seg5					vks232_dispram[2]-bit1-bit0  &~0x02
	2E,      2F,     //seg14   			vks232_dispram[7]-bit3-bit2
	2G,      2A,     //seg15				vks232_dispram[7]-bit1-bit0
	2C,      2B,     //seg16				vks232_dispram[8]-bit3-bit2	
	2D,      P2,     //seg17				vks232_dispram[8]-bit1-bit0
	3E,      3F,     //seg26   			vks232_dispram[13]-bit3-bit2
	3G,      3A,     //seg27				vks232_dispram[13]-bit1-bit0
	3C,      3B,     //seg28				vks232_dispram[14]-bit3-bit2	
	3D,      P3,     //seg29				vks232_dispram[14]-bit1-bit0
}
//M0=1 0BIAS 100%DUTY
//pin123-DSӸߵƽ
vks232_dispram[VKS232_SEGNUM]=
{//com1     com0 //ӦоƬSEG  ӦʾRAM
	1E,      1E,     //seg2   			vks232_dispram[0]-bit1
	1F,      1F,     //seg3   			vks232_dispram[0]-bit0
	1G,      1G,     //seg4					vks232_dispram[1]-bit3
	1A,      1A,     //seg5					vks232_dispram[1]-bit2
	1C,      1C,     //seg6					vks232_dispram[1]-bit1
	1B,      1B,     //seg7					vks232_dispram[1]-bit0
	1D,      1D,     //seg8					vks232_dispram[2]-bit3
	P1,      P1,     //seg9					vks232_dispram[2]-bit2
	2E,      2E,     //seg12   			vks232_dispram[3]-bit3
	2F,      2F,     //seg13   			vks232_dispram[3]-bit2
	2G,      2G,     //seg14				vks232_dispram[3]-bit1
	2A,      2A,     //seg15				vks232_dispram[3]-bit0
	2C,      2C,     //seg16				vks232_dispram[4]-bit3
	2B,      2B,     //seg17				vks232_dispram[4]-bit2
	2D,      2D,     //seg18				vks232_dispram[4]-bit1
	P2,      P2,     //seg19				vks232_dispram[4]-bit0
	3E,      3E,     //seg22   			vks232_dispram[5]-bit1
	3F,      3F,     //seg23   			vks232_dispram[5]-bit0
	3G,      3G,     //seg24				vks232_dispram[6]-bit3
	3A,      3A,     //seg25				vks232_dispram[6]-bit2
	3C,      3C,     //seg26				vks232_dispram[6]-bit1
	3B,      3B,     //seg27				vks232_dispram[6]-bit0
	3D,      3D,     //seg28				vks232_dispram[7]-bit3
	P3,      P3,     //seg29				vks232_dispram[7]-bit2
}
*/
/*8ֵ 
      4A
   6F    2B
      5G
	 7E    3C
	    1D    0dot
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xDE,0x06,0xB6,0x3E,0x6C,0x7A,0xFA,0x1C,0xFE,0x7E,0x20,0xC2,0xAA,0xEC,0x06
};
unsigned char vks232_addrbit=6;//icramַA5-A0,
unsigned char vks232_segi,vks232_comi;
unsigned char vks232_maxcom;//com4com3com2com
//ʾRAM bufferֻʹõ4λ
//M0=0 bit0->com0,bit1->com0,bit2->com0,bit3->com0
//M1=0 bit0->com0,bit1->com1,bit2->com0,bit3->com1
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVks232(void)
{
	VKS232_WR_L(); 
	delay_nus(VKS232_CLK);
	VKS232_WR_H();	
	delay_nus(VKS232_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVks232(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VKS232_CS_L();   //CS Ƭѡ   
	delay_nus(VKS232_CLK/2);
	VKS232_DATA_H();  
	WriteClockVks232();
	VKS232_DATA_L();  
	WriteClockVks232();
	VKS232_DATA_L();  
	WriteClockVks232();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VKS232_DATA_H(); 
	 else 
		 VKS232_DATA_L();	  

	 WriteClockVks232();
	 Shift = Shift >> 1;
	}
  VKS232_DATA_L(); 
	WriteClockVks232();	//һ0һλ X
  VKS232_CS_H(); 			//CS Ƭѡ  
	delay_nus(VKS232_CLK/2);
  VKS232_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVks232(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VKS232_CS_L();  //CS Ƭѡ
	delay_nus(VKS232_CLK/2);

	VKS232_DATA_H();  
	WriteClockVks232();  //101
	VKS232_DATA_L();  
	WriteClockVks232();
	VKS232_DATA_H();  
	WriteClockVks232();

	for( i = 0; i < vks232_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VKS232_DATA_H(); 		
		else  
			VKS232_DATA_L();
		WriteClockVks232();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VKS232_DATA_H();		 
   	else  
			VKS232_DATA_L();
		WriteClockVks232();
		Shift = Shift << 1;
	}   
  VKS232_CS_H(); //CS Ƭѡ
	delay_nus(VKS232_CLK/2);	
  VKS232_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVks232(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VKS232_CS_L();   //CS Ƭѡ 
	delay_nus(VKS232_CLK/2);

	VKS232_DATA_H();  
	WriteClockVks232();  //101
	VKS232_DATA_L();  
	WriteClockVks232();
	VKS232_DATA_H();  
	WriteClockVks232();

	Shift = 0x20;
	for( i = 0; i < vks232_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VKS232_DATA_H(); 		
		else  
			VKS232_DATA_L();
		WriteClockVks232();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VKS232_DATA_H();		 
			else  
				VKS232_DATA_L();
			WriteClockVks232();
			Shift = Shift << 1;
		}   
	}
  VKS232_CS_H();   //CS Ƭѡ
	delay_nus(VKS232_CLK/2);	 
  VKS232_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vks232_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[58];
	
#ifdef M0	//̬
	for(segi=0;segi<29;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVks232(0,dispram,29);//4bitַԶ1
#else  //1/2bias 1/2duty
	for(segi=0;segi<58;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVks232(0,dispram,58);//4bitַԶ1

#endif	
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_DisSegComOn(unsigned char seg,unsigned char com)
{	
	unsigned char dispram=0;
	
#ifdef M0		//̬
	if((seg%4)==0)
		dispram|=0x08;
	else if((seg%4)==1)
		dispram|=0x04;
	else if((seg%4)==2)
		dispram|=0x02;
	else if((seg%4)==3)
		dispram|=0x01;
	Write1DataVks232(seg/4,dispram);
#else  //1/2bias 1/2duty
	if((seg%2)==0)
	{
		if(com==1)
			dispram|=0x08;
		else if(com==0)
			dispram|=0x04;
	}
	else if((seg%2)==1)
	{
		if(com==1)
			dispram|=0x02;
		else if(com==0)
			dispram|=0x01;
	}
	Write1DataVks232(seg/2,dispram);
#endif	

}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_DisSegComOff(unsigned char seg,unsigned char com)
{
	unsigned char dispram=0;
	
#ifdef M0		//̬
	if((seg%4)==0)
		dispram&=~0x08;
	else if((seg%4)==1)
		dispram&=~0x04;
	else if((seg%4)==2)
		dispram&=~0x02;
	else if((seg%4)==3)
		dispram&=~0x01;
	Write1DataVks232(seg/4,dispram);
#else  //1/2bias 1/2duty
	if((seg%2)==0)
	{
		if(com==1)
			dispram|=~0xf8;
		else if(com==0)
			dispram|=~0xf4;
	}
	else if((seg%2)==1)
	{
		if(com==1)
			dispram|=~0xf2;
		else if(com==0)
			dispram|=~0xf1;
	}
	Write1DataVks232(seg/2,dispram);
#endif	

}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVks232(OSC_OFF);
	WriteCommandVks232(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_Exit_Standby(void)
{	
	//˳͹״̬vks232
	WriteCommandVks232(OSC_ON);
	WriteCommandVks232(DISP_ON);
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VKS232_CS_PORT, VKS232_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS232_RD_PORT, VKS232_RD_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS232_WR_PORT, VKS232_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VKS232_DAT_PORT, VKS232_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
//	GPIO_SetMode(VKS232_DAT_PORT, VKS232_DAT_PIN, GPIO_MODE_QUASI); //ҪΪ˫IOڶʱΪIO
		
	VKS232_CS_H();      
	VKS232_RD_H();  //RDŲߵƽ                  
	VKS232_WR_H();  
	VKS232_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vks232_Lowlevel_Init();
	//
#ifdef M0		//̬
	vks232_maxcom=1;
#else  //1/2bias 1/2duty
	vks232_maxcom=2;
#endif	
	WriteCommandVks232(OSC_ON);
	WriteCommandVks232(DISP_ON);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned char dat8;
	
#ifdef M0		//̬
	dat8=dat/100%10;	//ʾλ
	vks232_dispram[0]&=0x0C;
	vks232_dispram[0]=shuzi_zimo[dat8]>>6;
	vks232_dispram[1]&=0xf0;
	vks232_dispram[1]|=(shuzi_zimo[dat8]&0x3c)>>2;
	vks232_dispram[2]&=0x07;
	vks232_dispram[2]|=(shuzi_zimo[dat8]&0x02)<<2;
	
	dat8=dat/10%10; 	//ʾʮλ
	vks232_dispram[3]&=0xf0;
	vks232_dispram[3]=shuzi_zimo[dat8]>>4;
	vks232_dispram[4]&=0xf1;
	vks232_dispram[4]|=(shuzi_zimo[dat8]&0x0e);
	
	dat8=dat%10;			//ʾλ
	vks232_dispram[5]&=0x0C;
	vks232_dispram[5]=shuzi_zimo[dat8]>>6;
	vks232_dispram[6]&=0xf0;
	vks232_dispram[6]|=(shuzi_zimo[dat8]&0x3c)>>2;
	vks232_dispram[7]&=0x07;
	vks232_dispram[7]|=(shuzi_zimo[dat8]&0x02)<<2;
	if(dat<100)				//С100λʾ
	{
		vks232_dispram[0]&=0x0C;
		vks232_dispram[1]&=0xf0;
		vks232_dispram[2]&=0x07;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vks232_dispram[3]&=0xf0;
		vks232_dispram[4]&=0xf1;
	}
	//SEG11
//	Write1DataVks232(0,vks232_dispram[0]);
//	Write1DataVks232(1,vks232_dispram[1]);
//	Write1DataVks232(2,vks232_dispram[2]);
//	Write1DataVks232(3,vks232_dispram[3]);
//	Write1DataVks232(4,vks232_dispram[4]);
//	Write1DataVks232(5,vks232_dispram[5]);
//	Write1DataVks232(6,vks232_dispram[6]);
//	Write1DataVks232(7,vks232_dispram[7]);
	//SEGͶ	
	WritenDataVks232(0,&vks232_dispram[0],8);
#else  //1/2bias 1/2duty	
	dat8=dat/100%10;	//ʾλ
	vks232_dispram[1]&=0x0f;
	vks232_dispram[1]=shuzi_zimo[dat8]>>4;
	vks232_dispram[2]&=0xf1;
	vks232_dispram[2]|=shuzi_zimo[dat8]&0x0e;
	
	dat8=dat/10%10; 	//ʾʮλ
	vks232_dispram[7]&=0x0f;
	vks232_dispram[7]=shuzi_zimo[dat8]>>4;
	vks232_dispram[8]&=0xf1;
	vks232_dispram[8]|=shuzi_zimo[dat8]&0x0e;
	
	dat8=dat%10;			//ʾλ
	vks232_dispram[13]&=0x0f;
	vks232_dispram[13]=shuzi_zimo[dat8]>>4;
	vks232_dispram[14]&=0xf1;
	vks232_dispram[14]|=shuzi_zimo[dat8]&0x0e;
		
	if(dat<100)				//С100λʾ
	{
		vks232_dispram[1]&=0x0f;
		vks232_dispram[1]&=0xf1;
		vks232_dispram[2]&=0x0f;
		vks232_dispram[2]&=0xf1;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vks232_dispram[7]&=0x0f;
		vks232_dispram[7]&=0xf1;
		vks232_dispram[8]&=0x0f;
		vks232_dispram[8]&=0xf1;
	}
	//SEG11
	Write1DataVks232(1,vks232_dispram[1]);
	Write1DataVks232(2,vks232_dispram[2]);
	Write1DataVks232(7,vks232_dispram[7]);
	Write1DataVks232(8,vks232_dispram[8]);
	Write1DataVks232(13,vks232_dispram[13]);
	Write1DataVks232(14,vks232_dispram[14]);
	//SEGͶ
#endif	
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vks232_Main(void)
{	
	Vks232_Init();
	Vks232_DisAll(0x00);
	while(1)
	{
		Vks232_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vks232_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vks232_DisAll(0x00);			//LCDȫ
		for(vks232_segi=0;vks232_segi<VKS232_SEGNUM;vks232_segi++)//seg
		{
			for(vks232_comi=0;vks232_comi<vks232_maxcom;vks232_comi++)//com
			{
				Vks232_DisSegComOn(vks232_segtab[vks232_segi],vks232_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vks232_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vks232_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vks232_segi=0;vks232_segi<VKS232_SEGNUM;vks232_segi++)//seg
		{
			for(vks232_comi=0;vks232_comi<vks232_maxcom;vks232_comi++)//com
			{
				Vks232_DisSegComOff(vks232_segtab[vks232_segi],vks232_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vks232_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vks232_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vks232_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vks232_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
